import { __awaiter, __extends, __generator } from "tslib";
import dcopy from 'deep-copy';
import sanitizer from '../../_shared/utils/sanitizer';
import BaseCreatorApiConsumer from '../base-creator-api-consumer/base-creator-api-consumer';
var SdkCreatorApiConsumer = /** @class */ (function (_super) {
    __extends(SdkCreatorApiConsumer, _super);
    function SdkCreatorApiConsumer(SDKMethod, params) {
        var _this = _super.call(this, params) || this;
        _this.SDKMethod = SDKMethod;
        return _this;
    }
    SdkCreatorApiConsumer.prototype.createItem = function (_a) {
        var itemInstance = _a.itemInstance;
        var itemCopy = dcopy(itemInstance);
        if (this.preRequestHandler) {
            itemCopy = this.preRequestHandler(itemCopy);
        }
        if (this.fieldsToSend) {
            itemCopy = sanitizer(itemCopy, this.fieldsToSend);
        }
        return this._createItem([itemCopy]);
    };
    SdkCreatorApiConsumer.prototype.createNestedItem = function (_a) {
        var parentId = _a.parentId, itemInstance = _a.itemInstance;
        var itemCopy = dcopy(itemInstance);
        if (this.preRequestHandler) {
            itemCopy = this.preRequestHandler(itemCopy, parentId);
        }
        if (this.fieldsToSend) {
            itemCopy = sanitizer(itemCopy, this.fieldsToSend);
        }
        return this._createItem([parentId, itemCopy]);
    };
    SdkCreatorApiConsumer.prototype._createItem = function (args) {
        return __awaiter(this, void 0, void 0, function () {
            var response, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.SDKMethod.apply(this, args)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, this.responseHandler(response)];
                    case 2:
                        err_1 = _a.sent();
                        throw err_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return SdkCreatorApiConsumer;
}(BaseCreatorApiConsumer));
export default SdkCreatorApiConsumer;
//# sourceMappingURL=sdk-creator-api-consumer.js.map